<?php

  function array_deep_merge (array $arr1, array $arr2) : array {

    $arr = $arr1 + $arr2;

    foreach ($arr as $key => $value){
      if(is_array($value) && is_array($arr1[$key]) && is_array($arr2[$key])) {
        $arr[$key] = array_deep_merge($arr1[$key], $arr2[$key]);
      }
    }

    return $arr;
  }